unit main;
{
Pro kompilaci programu je treba mit v Delphi nainstalovanou TypeLibrary:
Microsoft XML, version 2.0 (Project->Import TypeLibrary), jejiz pouziti jsem
mel povolenou pritomnym dozorem
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, define, personform,contnrs, Menus, OleServer, MSXML_TLB;

type
  TMainForm = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Button3: TButton;
    Button4: TButton;
    Label13: TLabel;
    Label14: TLabel;
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    Databze1: TMenuItem;
    ARead: TMenuItem;
    OpenDialog: TOpenDialog;
    Doc: TDOMDocument;
    Rodokmen1: TMenuItem;
    APaint: TMenuItem;
    Ulodosouboru1: TMenuItem;
    Ukonit1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure AReadClick(Sender: TObject);
    procedure APaintClick(Sender: TObject);
    procedure Ukonit1Click(Sender: TObject);
  private
    FOsoby       : TObjectList;
    procedure VypisOsoby;
    function NajdiIDOsoby(const findid:string) : TOsoba;
    procedure LoadFromFile(const FileName : string);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation
uses view;

{$R *.DFM}

{ TForm1 }


procedure TMainForm.Button1Click(Sender: TObject);
{pridani nove osoby}
var Osoba:TOsoba;
begin
 Osoba:=TOsoba.Create;
 with TFormOsob.Create(Self) do
        if Execute(Osoba,FOsoby)
                then begin
                        FOsoby.Add(Osoba);
                        VypisOsoby;
                end
                else Osoba.Free;
end;

procedure TMainForm.VypisOsoby;
{vypsani informace do prave casti okna}
var i : integer;
begin
 ListBox1.Clear;
 for i:=0 to FOsoby.Count-1 do
        with TOsoba(FOsoby[i]) do begin
                ListBox1.Items.AddObject(Jmeno+' '+Prijmeni,FOsoby[i]);
        end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
 FOsoby:=TObjectList.Create(true);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
 FOsoby.Free;
end;

procedure TMainForm.Button2Click(Sender: TObject);
{vymazani osoby}
var Osoba : TOsoba;
begin
 if ListBox1.ItemIndex>-1 then begin
  Osoba:=ListBox1.Items.Objects[ListBox1.ItemIndex] as TOsoba;
  FOsoby.Remove(Osoba);
 end;
end;

procedure TMainForm.Button4Click(Sender: TObject);
var Osoba : TOsoba;
begin
 if ListBox1.ItemIndex>-1 then begin
  Osoba:=ListBox1.Items.Objects[ListBox1.ItemIndex] as TOsoba;
  with TFormOsob.Create(Self) do
        Execute(Osoba,FOsoby);
 end;
end;

procedure TMainForm.Button3Click(Sender: TObject);
var Osoba : TOsoba;
begin
 if ListBox1.ItemIndex>-1 then begin
  GroupBox1.Visible:=true;
  Osoba:=ListBox1.Items.Objects[ListBox1.ItemIndex] as TOsoba;
  with Osoba do begin
   Label5.Caption:=Jmeno;
   Label6.Caption:=Prijmeni;
   Label14.Caption:=PohlaviText[Pohlavi];
   Label7.Caption:=IntToStr(Narozeni);
   if Umrti >0
        then Label8.Caption:=IntToStr(Umrti)
        else Label8.Caption:='???';


   if Assigned(Otec)
        then Label11.Caption:=Otec.Jmeno+' '+Otec.Prijmeni
        else Label11.Caption:='';
   if Assigned(Matka)
        then Label12.Caption:=Matka.Jmeno+' '+Matka.Prijmeni
        else Label12.Caption:='';

  end;
 end else GroupBox1.Visible:=true;

end;

procedure TMainForm.AReadClick(Sender: TObject);
begin
 if OpenDialog.Execute
        then LoadFromFile(OpenDialog.FileName);
end;

procedure TMainForm.LoadFromFile;
{nacteni databaze z XML}
var FList : IXMLDOMNodeList;
    FNode : IXMLDomNode;
    i     : integer;

    procedure PridejOsobu(const Node : IXMLDomNode);
    var SubList : IXMLDOMNodeList;
        SubNode : IXMLDomNode;
        PomNode : IXMLDomNode;
        Value   : olevariant;
        i       : integer;
        Osoba   : TOsoba;
    begin
      SubList:=Node.Get_childNodes;
      Osoba:=TOsoba.Create;
      for i:=0 to SubList.length-1 do begin
       SubNode:=SubList.item[i];
       PomNode:=SubNode.firstChild;
       if Assigned(PomNode)
        then Value:=PomNode.Get_nodeValue
        else Value:=null;

       case GetTagNum(SubNode.nodeName) of
                Gid     : if not VarIsNull(Value)
                                then Osoba.Id:=Value;
                Gjmeno  : if not VarIsNull(Value)
                                then Osoba.Jmeno:=Value;
                Gprijmeni : if not VarIsNull(Value)
                                then Osoba.Prijmeni:=Value;
                GPohlavi  : if not VarIsNull(Value)
                                then if SubNode.Text[1] in [widechar('m'),widechar('M')]
                                        then Osoba.Pohlavi:=Muz
                                        else Osoba.Pohlavi:=Zena;
                Gnarozeni : if not VarIsNull(Value)
                                then try
                                        Osoba.Narozeni:=Value;
                                    except
                                        Osoba.Free;
                                        exit;
                                    end else begin
                                        Osoba.Free;
                                        exit;
                                end;
                Gumrti    : if not VarIsNull(Value)
                                then try
                                        Osoba.Umrti:=Value;
                                    except
                                        Osoba.Umrti:=-1;
                                    end else Osoba.Umrti:=-1;
                Gotec     : if not VarIsNull(Value)
                                then Osoba.Oid:=Value
                                else Osoba.Oid:='';                                
                Gmatka    : if not VarIsNull(Value)
                                then Osoba.Mid:=Value
                                else Osoba.Mid:='';
       end;
      end;
      FOsoby.Add(Osoba);
    end;


begin
 if Doc.load(FileName) then begin
  FOsoby.Clear;
  FList:=Doc.getElementsByTagName('rodokmen');
  FNode:=FList.item[0];
  FList:=FNode.childNodes;

  for i:=0 to FList.length-1 do begin
        FNode:=FList.item[i];
        if FNode.NodeName='osoba' then PridejOsobu(FNode);
  end;
  for i:=0 to FOsoby.Count-1 do
   with FOsoby[i] as TOsoba do begin
        Otec:=NajdiIDOsoby(Oid);
        Matka:=NajdiIDOsoby(Mid);
   end;
  VypisOsoby;
 end else ShowMessage('Nelze nast databzi!');
end;

function TMainForm.NajdiIDOsoby(const findid: string): TOsoba;
var i : integer;
begin
 Result:=nil;
 for i:=0 to FOsoby.Count-1 do
        with FOsoby[i] as TOsoba do if AnsiSameText(id,findid) then begin
                Result:=FOsoby[i] as Tosoba;
                break;
        end;
end;

procedure TMainForm.APaintClick(Sender: TObject);
begin
 with TForm1.Create(Self) do
        Vykresli(FOsoby);
end;

procedure TMainForm.Ukonit1Click(Sender: TObject);
begin
 Halt;
end;

end.
